<?php

/**
 * If called from a cache, Drupal wasn't bootstrapped and the following aren't
 * defined, so we define them.
 */
if (!defined('QUOVA_AD_FORMAT_ALL')) {
  define('QUOVA_AD_FORMAT_ALL', 0);
  define('QUOVA_AD_FORMAT_SELECTED', 1);
  define('QUOVA_AD_FORMAT_NOT_SELECTED', 2);
}


/**
 * Cache filter
 */
function quova_ad_cache_filter($ads) {
  $cache = adserve_cache('get_cache', 'geotarget');
  $valid = array();
  foreach ($ads as $aid) {
    if (quova_ad_is_displayable($cache['rules'][$aid], $cache['formats'])) {
      $valid[] = $aid;
    }
  }

  return $valid;
}


/**
 * Determine if the advertisement should be displayed.
 */
function quova_ad_is_displayable($rules, $formats) {
  $display = TRUE;
  foreach ($rules as $type => $targets) {
    $format = $formats[$type];

    switch ($format) {
      case QUOVA_AD_FORMAT_ALL:
        $display = TRUE;
        break;

      case QUOVA_AD_FORMAT_SELECTED:
        $display = FALSE;
        $location = quova_quick()->$type;
        if (in_array($location, $targets)) {
          $display = TRUE;
        }
        break;

      case QUOVA_AD_FORMAT_NOT_SELECTED:
        $display = TRUE;
        $location = quova_quick()->$type;
        if (in_array($location, $targets)) {
          $display = FALSE;
        }
        break;
    }
  }

  return $display;
}
